-- name: [CS] FNF Boyfriend
-- description: Boyfriend from the hit game Friday Night Funkin'! (V2.5)
-- category: cs

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
    
    Note: If there are some functionalities you don't care
    to add such as palettes, you can freely remove the function
    for it, the only function you require is character_add
]]

local TEXT_MOD_NAME = "[CS] FNF BOYFRIEND (V2.5)"

-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MODEL_BOYFRIEND = smlua_model_util_get_id("Boyfriend_geo")
local E_MODEL_MICFRIEND = smlua_model_util_get_id("BoyfriendMIC_geo") -- Located in "actors"
local E_MODEL_BFXMAS = smlua_model_util_get_id("BF_Xmas_geo") -- Located in "actors"

local TEX_LIFEBF = get_texture_info("bf-icon") -- Located in "textures"
--local TEX_CUSTOM_STAR_ICON = get_texture_info("exclamation-icon") -- Located in "textures"

-- All Located in "sound"
local VOICETABLE_BF = {
    [CHAR_SOUND_ATTACKED] = 'Damage.ogg',
	[CHAR_SOUND_EEUH] = 'uuu.ogg',
	[CHAR_SOUND_LETS_A_GO] = 'Yeah_Short.ogg',
    [CHAR_SOUND_DROWNING] = 'Death.ogg',
    [CHAR_SOUND_DYING] = 'Death.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'wah2.ogg',
    [CHAR_SOUND_HAHA] = 'Hey.ogg',
    [CHAR_SOUND_HAHA_2] = 'Hey.ogg',
	[CHAR_SOUND_DOH] = 'oof-doh.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'YEAH.ogg',
    [CHAR_SOUND_HOOHOO] = {'2ndjump2.ogg'},
    [CHAR_SOUND_MAMA_MIA] = 'MammaMia.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'YEAH2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Damage.ogg',
    [CHAR_SOUND_OOOF] = 'oof-doh.ogg',
    [CHAR_SOUND_OOOF2] = 'oof-doh.ogg',
	[CHAR_SOUND_HRMM] = 'grabobj.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'punch_hoo.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'punch_2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'punch1.ogg',
	[CHAR_SOUND_UH] = 'u.ogg',
    [CHAR_SOUND_UH2] = 'u.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'so_long.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'boing.ogg',
    [CHAR_SOUND_WAAAOOOW] ='AHHHHHHH.ogg',
    [CHAR_SOUND_WAH2] = 'wah2.ogg',
    [CHAR_SOUND_WHOA] = 'woah.ogg',
    [CHAR_SOUND_YAHOO] = 'yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'3jump_3.ogg', '3jump_4.ogg', 'yahoo.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'1jump_1.ogg', '1jump_6.ogg', '1jump_5.ogg', '3jump_2.ogg', '1jump_4.ogg', '1jump7.ogg', '1jump_8.ogg',},
}

-- All Located in "actors"
local CAPTABLE_BF = {
    normal = smlua_model_util_get_id("bfcap_geo"),
    wing = smlua_model_util_get_id("bfwcap_geo"),
    metal = smlua_model_util_get_id("bfmcap_geo"),
    metalWing = smlua_model_util_get_id("bfwcap_geo"),
}

--local E_MODEL_CUSTOM_STAR = smlua_model_util_get_id("custom_model_star_geo") -- Located in "actors"

local PALETTE_BF = {
    [PANTS]  = { r = 0x00, g = 0x44, b = 0xCC },
    [SHIRT]  = { r = 0xFE, g = 0xEB, b = 0xF7 },
    [GLOVES] = { r = 0xFE, g = 0xEB, b = 0xF7 },
    [SHOES]  = { r = 0xFF, g = 0x1B, b = 0x1F },
    [HAIR]   = { r = 0x66, g = 0xFF, b = 0xFF },
    [SKIN]   = { r = 0xFD, g = 0xC7, b = 0xA1 },
    [CAP]    = { r = 0xFF, g = 0x1B, b = 0x1F },
    [EMBLEM] = { r = 0xFF, g = 0x1B, b = 0x1F }
}
local PALETTE_BFXMAS = {
    [PANTS]  = { r = 0x00, g = 0x44, b = 0xCC },
    [SHIRT]  = { r = 0xFF, g = 0x1B, b = 0x1F },
    [GLOVES] = { r = 0xFE, g = 0xEB, b = 0xF7 },
    [SHOES]  = { r = 255, g = 138, b = 72 },
    [HAIR]   = { r = 0x66, g = 0xFF, b = 0xFF },
    [SKIN]   = { r = 0xFD, g = 0xC7, b = 0xA1 },
    [CAP]    = { r = 0xFF, g = 0x1B, b = 0x1F },
    [EMBLEM] = { r = 0xFF, g = 0x1B, b = 0x1F }
}

--[[
-- All Located in "textures"
local healthMeter = {
    label = {
        left = get_texture_info("template-hp-back-left"),
        right = get_texture_info("template-hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("template-hp-pie-1"),
        [2] = get_texture_info("template-hp-pie-2"),
        [3] = get_texture_info("template-hp-pie-3"),
        [4] = get_texture_info("template-hp-pie-4"),
        [5] = get_texture_info("template-hp-pie-5"),
        [6] = get_texture_info("template-hp-pie-6"),
        [7] = get_texture_info("template-hp-pie-7"),
        [8] = get_texture_info("template-hp-pie-8"),
    }
}
]]

local CSloaded = false
local function on_character_select_load()
    CT_BOYFRIEND = _G.charSelect.character_add("Boyfriend", {"Beep bop bo!", "The Boyfriend from the hit game Friday Night Funkin'", "in takes his way in super mario 64!",}, "Wall_E20", {r = 0, g = 137, b = 255}, E_MODEL_BOYFRIEND, CT_TOAD, TEX_LIFEBF, 0.8)
    _G.charSelect.character_add_caps(E_MODEL_BOYFRIEND, CAPTABLE_BF)
    _G.charSelect.character_add_voice(E_MODEL_BOYFRIEND, VOICETABLE_BF)
  --  _G.charSelect.character_add_celebration_star(E_MODEL_BOYFRIEND, E_MODEL_CUSTOM_STAR, TEX_CUSTOM_STAR_ICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_BOYFRIEND, PALETTE_BF)
	_G.charSelect.character_add_palette_preset(E_MODEL_BFXMAS, PALETTE_BFXMAS)
	_G.charSelect.character_add_voice(E_MODEL_BFXMAS, VOICETABLE_BF)
	_G.charSelect.character_add_caps(E_MODEL_BFXMAS, CAPTABLE_BF)
	_G.charSelect.character_add_caps(E_MODEL_MICFRIEND, CAPTABLE_BF)
	_G.charSelect.character_add_voice(E_MODEL_MICFRIEND, VOICETABLE_BF)
	_G.charSelect.character_add_palette_preset(E_MODEL_MICFRIEND, PALETTE_BF)
local SKIN_BFXMAS = {
        { model = E_MODEL_BFXMAS,  name = "Boyfriend (Xmas)", desc = { "Bop be boo" , "Boyfriend as seen in Week 5!" }, color = {r = 255, g = 0, b = 0 } }
    }

    for index, alt in ipairs(SKIN_BFXMAS) do
        _G.charSelect.character_add_costume(CT_BOYFRIEND, alt.name, alt.desc, nil, alt.color, alt.model, nil, nil, nil, nil)
    end
    --_G.charSelect.character_add_health_meter(CT_CHAR, healthMeter)

    CSloaded = true

local SKIN_BFMIC = {
        { model = E_MODEL_MICFRIEND,  name = "Boyfriend (Microphone)", desc = { "Be bo bai" , "Boyfriend Redy to rap battle!" }, color = {r = 0, g = 137, b = 255} }
    }

    for index, alt in ipairs(SKIN_BFMIC) do
        _G.charSelect.character_add_costume(CT_BOYFRIEND, alt.name, alt.desc, nil, alt.color, alt.model, nil, nil, nil, nil)
    end
    --_G.charSelect.character_add_health_meter(CT_CHAR, healthMeter)
    CSloaded = true

end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BF then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_BF then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)
